#!/usr/bin/python2.5
import sys,time
import re
import os
import urllib
import urllib2

from subprocess import Popen,PIPE

from PyQt4 import QtGui,QtCore
from PyQt4.QtGui import *
from pyPianobar_ui import *

import gobject, dbus
from dbus.mainloop.glib import DBusGMainLoop


class retrieveAlbum(QtCore.QThread):
	def __init__(self):
		self.iUrl = ""
		QtCore.QThread.__init__(self)

	def conf (self,artist,album):
		album = album.replace("(Radio Single)","")
		album = album.replace("(Explicit)","")
		album = re.sub("[^A-Za-z\s]","",album.rstrip().lstrip())
		data = { 'artist': artist, 'album': album }
		self.url_value = urllib.urlencode(data)
	
	def run(self):
		__pyqtSignals__ = ( "album" )
		url = 'http://www.slothradio.com/covers?' + self.url_value
		self.response = urllib2.urlopen(url) 
		page = self.response.read()
		datastart = page.find('<div class="album0"><img src="', 0) + 30
		if datastart > 30:
			dataend = page.find('"',datastart)
			self.iUrl = page[datastart:dataend]
		else:
			self.iUrl = "None"
			
		self.emit(QtCore.SIGNAL("album"))
		self.response.close

class Config:
	def __init__(self):
		self.user = ""
		self.password = ""
		self.color = ""
		self.control_proxy = ""
		self.act_help = "?"
		self.act_songlove = "+"
		self.act_songban = "-"
		self.act_stationaddmusic = "a"
		self.act_stationcreate = "c"
		self.act_stationdelete = "d"
		self.act_songexplain = "e"
		self.act_stationaddbygenre = "g"
		self.act_songinfo = "i"
		self.act_addshared = "j"
		self.act_songmove = "m"
		self.act_songnext = "n"
		self.act_songpause = "p"
		self.act_quit = "q"
		self.act_stationrename = "r"
		self.act_stationchange = "s"
		self.act_songtired = "t"
		self.act_upcoming = "u"
		self.act_stationselectquickmix = "x"
		self.audio_format = "mp3"
		self.autostart_station = ""
		self.lastplayed = ""
		self.config_opts = ['user','password',
			'control_proxy','act_help','act_songlove','act_songban', 'act_stationaddmusic',
			'act_stationcreate', 'act_stationdelete', 'act_songexplain', 'act_stationaddbygenre',
			'act_songinfo', 'act_addshared', 'act_songmove', 'act_songpause', 'act_quit', 
			'act_stationrename', 'act_stationchange', 'act_songtired', 'act_upcoming', 
			'act_stationselectquickmix', 'audio_format', 'autostart_station', 'event_command']
		self.event_command = ""
		
	def load(self):
		if os.path.exists(os.path.expanduser("~")+'/.config/pianobar/history'):
			os.remove(os.path.expanduser("~")+'/.config/pianobar/history')

		if os.path.exists('/etc/hildon/theme/colors.config'):
			f = open('/etc/hildon/theme/colors.config')
			for line in f:
				if re.match("ActiveTextColor\s*=",line):
					self.color = re.match("ActiveTextColor\s*=(.+)",line).group(1).lstrip().rstrip()
				
			if self.color == "":
				self.color = "rgb(255, 255, 255)"

		else:
			self.color = "rgb(255, 255, 255)"
		
		if os.path.exists(os.path.expanduser("~")+'/.config/pianobar/config'):
			f = open(os.path.expanduser("~")+'/.config/pianobar/config', 'r')
			for line in f:
				line = line.replace(" ", "")
				
				if re.match("^#.*",line) is not None:
					continue
			
				for opt in self.config_opts:
					if re.match("^"+opt+"=(.+)$",line) is not None:
						setattr(self,opt,self.get_var(opt,line))
			f.close()

		if os.path.exists(os.path.expanduser("~")+'/.config/pianobar/lastplayed'):
			f = open(os.path.expanduser("~")+'/.config/pianobar/lastplayed', 'r')
			self.lastplayed = f.readline().replace("\n","")
			f.close()
		
	def write(self):
		newfile = ""
		if os.path.exists(os.path.expanduser("~")+'/.config/pianobar/config'):
			f = open(os.path.expanduser("~")+'/.config/pianobar/config', 'r')
			for line in f:
				line = line.replace(" ", "")
				if len(self.user)>0 and re.match("#*user=",line) is not None:
					newfile+="user="+self.user+"\n"
				elif len(self.password)>0 and re.match("#*password=",line) is not None:
					newfile+="password="+self.password+"\n"
				else:
					newfile+=line
			f.close()
		else:
			if not os.path.exists(os.path.expanduser("~")+'/.config'):
				os.mkdir(os.path.expanduser("~")+'/.config')

			if not os.path.exists(os.path.expanduser("~")+'/.config/pianobar'):
				os.mkdir(os.path.expanduser("~")+'/.config/pianobar')
			for opt in self.config_opts:
				if len(getattr(self,opt))>0:
					newfile+=opt+"="+getattr(self,opt)+"\n"
				else:
					newfile+="#"+opt+"="+getattr(self,opt)+"\n"

		f = open(os.path.expanduser("~")+'/.config/pianobar/config', 'w')
		newfile = newfile.replace("=", " = ")
		f.write(newfile)
		f.close()

	def get_var(self,var,line):
		r = re.match("^"+var+"=(.+)$",line)
		return r.group(1)

class snooze(QtCore.QThread):
	__pyqtSignals__ = ( "shutdown" )

	def __init__(self,time):
		self.time = time
		QtCore.QThread.__init__(self)
		self.cont = 1
	
	def run(self):
		time.sleep(self.time*60)
		if self.cont:
			self.emit(QtCore.SIGNAL("shutdown"))
			
			
		
class tPandora(QtCore.QThread):

	__pyqtSignals__ = ( "stations","newsong", "showUsername", "showPassword", "oops", "second", "autoPlay" )

	def __init__(self, c):
		self.sTitle = ""
		self.sArtist = ""
		self.sAlbum = ""
		self.sLike = ""
		self.last = ""
		self.playing = 0
		self.drun = 1
		self.stations = [""] 
		self.length = ""
		self.error = ""
		self.crash = 0
		self.c = c
		QtCore.QThread.__init__(self)
	
	def save_love(self):
		song = self.sTitle + " by " + self.sArtist + " on " + self.sAlbum
		f = open(os.path.expanduser("~")+'/.config/pianobar/history', 'a')
		f.write(song+"\n")
		f.close()

	def run(self):
		self.pandora = Popen("pianobar",stdout=PIPE,stdin=PIPE)
		newline = ""
		listStation = 0
		while self.drun:
			char = self.pandora.stdout.read(1)
			newline += char
			if re.match(".+Username$",newline) is not None and "Error" not in newline:
				self.emit(QtCore.SIGNAL("showUsername"), self.sTitle)
				self.last = "username"
					
			if re.match(".+Password$",newline) is not None:
				self.emit(QtCore.SIGNAL("showPassword"), self.sTitle)
				self.last = "password"

			if re.match(".+Select station: $",newline) is not None:
				if not self.last == "quickswitch":
					self.emit(QtCore.SIGNAL("autoPlay"), self.sTitle)
			
			elif char == "\n":
				output = newline.split("|>")
				newline = ""
				for line in output:
					if line == "":
						continue
					title = re.match(".+\"(.+)\".+by.+\"(.+)\".+on.+\"(.+)\"(.*)",line)
					stations = re.match("\s+(\d+)\)\s(.+)$",line)
					merror = re.match(".*Error: (.+)$",line)
						
					if merror is not None:
						self.error = merror.group(1)
						self.emit(QtCore.SIGNAL("oops"))
						self.drun = 0
						self.pandora.stdin.close()
						self.pandora.stdout.close()

					if stations is not None:
						if int(stations.group(1)) == 0:
							self.stations = []
							self.crash = 0

						if re.match("^[Q|q]\s+(.+)",stations.group(2).lstrip()):
							station = re.match("^[Q|q]\s+(.+)",stations.group(2).lstrip()).group(1) + " *"
						else:
							station = stations.group(2).lstrip()

						if len(self.stations) > int(stations.group(1)):
							
							self.stations[int(stations.group(1))] = station
						else:
							self.stations.append(station)
						
						if not self.last == "quickswitch":
							self.last = "stations"
						self.emit(QtCore.SIGNAL("stations"), self.sTitle)
						
					
					if title is not None:
						self.close = 0
						self.sTitle = title.group(1)
						self.sArtist = title.group(2)
						self.sAlbum = title.group(3)
						if re.match(".+\<3",title.group(4)):
							self.sLike = 1
							self.save_love()
						else:
							self.sLike = 0
						
						self.last = "song"
						self.emit(QtCore.SIGNAL("newsong"), self.sTitle)
		
			elif re.match("^.+(\d+\:\d+)\/(\d+\:\d\d)$",newline):
				stime = re.match("^.+(\d+\:\d+)\/(\d+\:\d\d)$",newline)
				self.length = stime.group(1)+"/"+stime.group(2)
				self.emit(QtCore.SIGNAL("second"))
				newline = ""
			else:
				continue
			

class MyForm(QtGui.QMainWindow):
	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.station = 0;
		self.ui = Ui_pyPianobar()
		self.ui.setupUi(self)
		self.c = Config()
		self.c.load()
		self.s = snooze(0)
		self.p = tPandora(self.c)
		self.p.start()
		self.a = retrieveAlbum()
		sysbus = dbus.SystemBus()
		self.fmtx = sysbus.get_object('com.nokia.FMTx', '/com/nokia/fmtx/default', False)
		self.fmtx_iface = dbus.Interface(self.fmtx, dbus_interface='org.freedesktop.DBus.Properties')

		state = self.fmtx_iface.Get("com.nokia.FMTx.Device", "state")
		if state == 'enabled':
			self.ui.actionEnable_FM_Radio.setText(QtGui.QApplication.translate("pyPianobar", "Disable FM Tx", None, QtGui.QApplication.UnicodeUTF8))
		else:
			self.ui.actionEnable_FM_Radio.setText(QtGui.QApplication.translate("pyPianobar", "Enable FM Tx", None, QtGui.QApplication.UnicodeUTF8))
		
		QtCore.QObject.connect(self.p, QtCore.SIGNAL('newsong'), self.newsong)
		QtCore.QObject.connect(self.p, QtCore.SIGNAL('stations'), self.stations)
		QtCore.QObject.connect(self.p, QtCore.SIGNAL('oops'), self.doError)
		QtCore.QObject.connect(self.p, QtCore.SIGNAL('showUsername'), self.showUsername)
		QtCore.QObject.connect(self.p, QtCore.SIGNAL('showPassword'), self.showPassword)
		QtCore.QObject.connect(self.p, QtCore.SIGNAL('autoPlay'), self.autoPlay)
		QtCore.QObject.connect(self.p, QtCore.SIGNAL('second'), self.uSecond)
		QtCore.QObject.connect(self.s, QtCore.SIGNAL('shutdown'), self.sQuit)
		QtCore.QObject.connect(self.a, QtCore.SIGNAL('album'), self.uAlbum)
		QtCore.QObject.connect(self.ui.btnLove, QtCore.SIGNAL('clicked()'), self.doLove)
		QtCore.QObject.connect(self.ui.btnHate, QtCore.SIGNAL('clicked()'), self.doHate)
		QtCore.QObject.connect(self.ui.btnNext, QtCore.SIGNAL('clicked()'), self.doNext)
		QtCore.QObject.connect(self.ui.btnPlay, QtCore.SIGNAL('clicked()'), self.doPlayPause)
		QtCore.QObject.connect(self.ui.btnSleep, QtCore.SIGNAL('clicked()'), self.tiredSong)
		QtCore.QObject.connect(self.ui.actionUser_Pass, QtCore.SIGNAL('triggered()'), self.setUserPass)
		QtCore.QObject.connect(self.ui.actionDelete, QtCore.SIGNAL('triggered()'), self.deleteStation)
		QtCore.QObject.connect(self.ui.actionCreate, QtCore.SIGNAL('triggered()'), self.createStation)
		QtCore.QObject.connect(self.ui.actionSnooze, QtCore.SIGNAL('triggered()'), self.setSnooze)
		QtCore.QObject.connect(self.ui.actionEnable_FM_Radio, QtCore.SIGNAL('triggered()'), self.doFM)
		QtCore.QObject.connect(self.ui.btnNext, QtCore.SIGNAL('pressed()'), self.nextDown)
		QtCore.QObject.connect(self.ui.btnNext, QtCore.SIGNAL('released()'), self.nextUp)
		QtCore.QObject.connect(self.ui.btnSleep, QtCore.SIGNAL('pressed()'), self.sleepDown)
		QtCore.QObject.connect(self.ui.btnSleep, QtCore.SIGNAL('released()'), self.sleepUp)
		QtCore.QObject.connect(self.ui.btnHate, QtCore.SIGNAL('pressed()'), self.hateDown)
		QtCore.QObject.connect(self.ui.btnHate, QtCore.SIGNAL('released()'), self.hateUp)
		QtCore.QObject.connect(self.ui.listStations, QtCore.SIGNAL('activated(int)'), self.setStation)
		QtCore.QObject.connect(self, QtCore.SIGNAL('triggered()'), self.closeEvent)

	def doFM(self):
		state = self.fmtx_iface.Get("com.nokia.FMTx.Device", "state")
		if state == 'disabled':
			self.ui.actionEnable_FM_Radio.setText(QtGui.QApplication.translate("pyPianobar", "Disable FM Tx", None, QtGui.QApplication.UnicodeUTF8))
			self.fmtx_iface.Set("com.nokia.FMTx.Device", "state", dbus.String(u'%s' % 'enabled', variant_level=1))
		else:
			self.ui.actionEnable_FM_Radio.setText(QtGui.QApplication.translate("pyPianobar", "Enable FM Tx", None, QtGui.QApplication.UnicodeUTF8))
			self.fmtx_iface.Set("com.nokia.FMTx.Device", "state", dbus.String(u'%s' % 'disabled', variant_level=1))

	def autoPlay(self):
		i = -1
		self.station = i
		for station in self.p.stations:
			i = i + 1
			if self.c.lastplayed == station.rstrip(" *"):
				self.station = i
		if not self.station == -1:
			self.p.pandora.stdin.write(str(self.station)+"\n")
			self.ui.btnPlay.setStyleSheet("background-color: "+ self.c.color + ";\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/playing-trans.png);")
			self.ui.listStations.setCurrentIndex(self.station)

	def setUserPass(self):
		self.showUsername()
		self.showPassword()

	def createStation(self):
		station, ok = QtGui.QInputDialog.getText(self,"Artist or Track Name", "Enter an Artist or Track Name:")
		if len(station)>0:
			if self.p.last == "stations":
				self.p.pandora.stdin.write("\n")

			self.p.pandora.stdin.write(self.c.act_stationcreate)
			self.p.pandora.stdin.write(station+"\n")
			self.station = 0
			what = QtGui.QMessageBox.question(self, 'Artist or Track?', 'Is this an artist or track name?','Artist','Track')
			if what == 0:
				self.p.pandora.stdin.write("a")
			else:
				self.p.pandora.stdin.write("t")

			ok = QtGui.QMessageBox.warning(self,'Select Match','Select the closest title from the station drop down.')
			self.p.last = 'create'

	def deleteStation(self):
		reply = QtGui.QMessageBox.question(self, 'Delete Station',
			"Really delete "+self.ui.listStations.currentText()+"?", QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
		if reply == QtGui.QMessageBox.Yes:
			if self.p.last == "song":
				self.p.pandora.stdin.write(self.c.act_stationchange)
				self.ui.btnPlay.setStyleSheet("background-color: "+ self.c.color + ";\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/paused-trans.png);")
				self.p.playing = 0
			self.p.pandora.stdin.write(str(self.ui.listStations.currentIndex())+"\n")
			self.p.pandora.stdin.write(self.c.act_stationdelete)
			self.p.pandora.stdin.write("y\n")
			self.p.pandora.stdin.write(self.c.act_stationchange)
			self.station = 0
	
	def stations(self):
		self.ui.listStations.clear()
		for station in self.p.stations:
			self.ui.listStations.addItem(station)
			self.ui.listStations.setCurrentIndex(self.station)

	def setStation(self, listaItem):
		self.ui.btnNext.setFocus()
		if self.p.last == 'create':
			self.p.pandora.stdin.write(str(self.ui.listStations.currentIndex())+"\n")
			QtGui.QMessageBox.warning(self, 'Station Created', 'Your station has been created.')
			self.c.lastplayed = self.ui.listStations.currentText()+" Radio"
			f = open(os.path.expanduser("~")+'/.config/pianobar/lastplayed', 'w')
			f.write(self.ui.listStations.currentText().replace(" *", ""))
			f.close()
			self.p.pandora.stdin.write(self.c.act_stationchange)
		else:
			if self.p.last == "song":
				self.p.last = "quickswitch"
				self.p.pandora.stdin.write(self.c.act_stationchange)
		
			self.station = self.ui.listStations.currentIndex()
			self.p.pandora.stdin.write(str(self.station)+"\n")
			self.ui.btnPlay.setStyleSheet("background-color: "+ self.c.color + ";\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/playing-trans.png);")
			f = open(os.path.expanduser("~")+'/.config/pianobar/lastplayed', 'w')
			self.ui.listStations.currentText()
			f.write(self.ui.listStations.currentText().replace(" *", ""))
			f.close()

	def tiredSong(self):
		if self.p.last == "song":
			check = QtGui.QMessageBox.question(self, 'Are you sure?', 'Are you tired of the song ' + self.p.sTitle + '?','No','Yes')
			if check == 1:
				self.p.pandora.stdin.write(self.c.act_songtired)
			
	def setSnooze(self):
		time,ok = QtGui.QInputDialog.getText(self,"Snooze", "Enter a time, in minutes, to shutdown:")
		if ok:
			self.s.time = int(time)
			self.s.start()

	def uSecond(self):
		self.ui.lblTime.setText(self.p.length)

	def newsong(self):
		self.setWindowTitle(QtGui.QApplication.translate("pyPianobar", "\"" + self.p.sTitle + "\"" + " by " + self.p.sArtist + " - pyPianobar", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.albumArt.setHtml("")
		self.ui.lblAlbum.setText("on: " + self.p.sAlbum)
		self.a.conf (self.p.sArtist,self.p.sAlbum)
		self.a.start()
		if self.p.sLike:
			self.ui.btnLove.setStyleSheet("background-color: "+ self.c.color + ";\n"
			"border: rgb(0, 0, 0);\nbackground-image: url(:/img/img/Thumbs-up-right-trans.png);")
		else:
			self.ui.btnLove.setStyleSheet("background-image: url(:/img/img/Thumbs-up-right-trans.png);\nborder: rgb(0, 0, 0);\nbackground-color: rgb(0, 0, 0);")

		if not self.p.playing:
			self.ui.btnPlay.setStyleSheet("background-image: url(:/img/img/playing-trans.png);\nborder: rgb(0, 0, 0);\nbackground-color: "+ self.c.color + ";")
			self.p.playing = 1

	def uAlbum(self):
		if not self.a.iUrl == "None":
			#myUrl = QtCore.QUrl.fromEncoded(self.a.iUrl)
			#self.ui.albumArt.load(myUrl)
			self.ui.albumArt.setHtml("<img style='width: 100%; height: 95%' src='"+self.a.iUrl+"'>")
		else:
			self.ui.albumArt.setHtml("<img style='widt: 100%; height: 95%' src='qrc:///img/img/no-image-trans.png'>")
		
	def doLove(self):
		if self.p.last == "song":
	 		self.p.pandora.stdin.write(self.c.act_songlove)
			self.p.save_love()
			self.ui.btnLove.setStyleSheet("background-color: "+ self.c.color +";\n"
			"border: rgb(0, 0, 0);\nbackground-image: url(:/img/img/Thumbs-up-right-trans.png);")
			self.ui.btnNext.setFocus()
	
	def doHate(self):
		if self.p.last == "song":
			self.p.pandora.stdin.write(self.c.act_songban)

	def nextDown(self):
		self.ui.btnNext.setStyleSheet("background-color: " + self.c.color + ";\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/skip-trans.png);")

	def nextUp(self):
		self.ui.btnNext.setStyleSheet("background-color: rgb(0, 0, 0);\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/skip-trans.png);")

	def sleepDown(self):
		self.ui.btnSleep.setStyleSheet("background-color: " + self.c.color + ";\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/minus-trans.png);")

	def sleepUp(self):
		self.ui.btnSleep.setStyleSheet("background-color: rgb(0, 0, 0);\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/minus-trans.png);")

	def hateDown(self):
		self.ui.btnHate.setStyleSheet("background-color: " + self.c.color + ";\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/thumbs-down-trans.png);")

	def hateUp(self):
		self.ui.btnHate.setStyleSheet("background-color: rgb(0, 0, 0);\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/thumbs-down-trans.png);")

	def doNext(self):
		if self.p.last == "song":
			self.p.pandora.stdin.write(self.c.act_songnext)

	def doPlayPause(self):
		if self.p.last == "stations":
			self.p.pandora.stdin.write(str(self.ui.listStations.currentIndex())+"\n")
			f = open(os.path.expanduser("~")+'/.config/pianobar/lastplayed', 'w')
			f.write(self.ui.listStations.currentText().replace(" *", ""))
			f.close()
		else:
			self.p.pandora.stdin.write(self.c.act_songpause)

		if self.p.playing:
			self.ui.btnPlay.setStyleSheet("background-color: "+ self.c.color +";\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/paused-trans.png);")
			self.ui.btnNext.setFocus()
			self.p.playing = 0
		else:
			self.ui.btnPlay.setStyleSheet("background-color: "+ self.c.color +";\nborder: rgb(0, 0, 0);\nbackground-image: url(:/img/img/playing-trans.png);")
			self.ui.btnNext.setFocus()
			self.p.playing = 1
	
	def sQuit(self):
		self.p.drun = 0
		self.p.pandora.stdin.write('\n'+self.c.act_quit)
		self.p.pandora.wait()
		self.p.exit()
		self.doQuit()
	
	def closeEvent(self, event):
		self.p.drun = 0
		self.p.pandora.stdin.write('\n'+self.c.act_quit)
		self.p.pandora.wait()
		self.p.exit()
		self.doQuit()

	
	def doError(self):
		if self.p.crash < 2:
			ok = QtGui.QMessageBox.warning( self, "Pianobar Error", "Pianobar experienced an error.\nPianobar Output:\n" + self.p.error + "\nRestarting Pianobar.", QtGui.QMessageBox.Ok )
			if re.match("^Username and/or password not correct.+",self.p.error) is not None:
				self.showUsername()
				self.showPassword()
			self.p.crash += 1
			self.p.drun = 0
			if not self.p.pandora.stdin.closed:
				self.p.pandora.stdin.write('\n'+self.c.act_quit+'\n\n')
			self.p.pandora.wait()
			self.p.drun = 1
			self.p.start()
		else:
			ok = QtGui.QMessageBox.warning( self, "Pianobar Error", "Pianobar crashed 3 times in a row.\nPianobar Output:\n" + self.p.error + "\nQuitting now..", QtGui.QMessageBox.Ok )
			self.p.drun = 0
			self.p.pandora.wait()
			self.p.exit()
			self.doQuit()
			
		
	def doQuit(self):
		quit()
	
	def showUsername(self):
		username,ok = QtGui.QInputDialog.getText(self,"Username", "Pandora Username:", QLineEdit.Normal,self.c.user)
		if ok:
			self.c.user = username
			if self.p.last == "username":
				self.p.pandora.stdin.write(self.c.user+"\n")
		elif self.p.last == "username":
			self.p.drun = 0
			self.p.exit()
			self.doQuit()
	
	def showPassword(self):
		password,ok = QtGui.QInputDialog.getText(self,"Password", "Pandora Password:",QLineEdit.Password)
		if ok:
			self.c.password = password
			if self.p.last == "password" and not self.p.pandora.stdin.closed:
				self.p.pandora.stdin.write(self.c.password+"\n")
			self.c.write()
		elif self.p.last == "password":
			self.p.drun = 0
			self.p.exit()
			self.doQuit()

if __name__ == "__main__":
	app = QtGui.QApplication(sys.argv)
	myapp = MyForm()
	myapp.show()
	sys.exit(app.exec_())
